package q1k2.pxlx.train.enums;

import kd.bos.util.StringUtils;

/**
 * @Description 试题类型枚举
 * @Date 2024/7/2 16:35
 * @Created by 刘维
 */
public enum QuestionTypeEnum {
    SINGLE("单选", "SINGLE"),
    MULTISELECT("多选", "MULTISELECT"),
    QUESTION("问答", "QUESTION"),
    SECTION("段落", "SECTION");

    private final String name;
    private final String value;

    QuestionTypeEnum(String name, String value) {
        this.name = name;
        this.value = value;
    }

    public static QuestionTypeEnum getEnum(String value) {
        QuestionTypeEnum questionType = null;
        if (!StringUtils.isEmpty(value)) {
            QuestionTypeEnum[] values = QuestionTypeEnum.values();
            for (QuestionTypeEnum typeEnum : values) {
                if (typeEnum.getValue().equals(value)) {
                    questionType = typeEnum;
                    break;
                }
            }
        }
        return questionType;
    }

    public String getName() {
        return name;
    }

    public String getValue() {
        return value;
    }

}
