package q1k2.pxlx.train.plugin.form;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Maps;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.ext.form.control.CustomControl;
import kd.bos.form.CloseCallBack;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.events.ItemClickEvent;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.events.CustomEventArgs;
import kd.bos.list.ListFilterParameter;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;
import q1k2.pxlx.train.common.Q1k2SurveyLwConstant;
import q1k2.pxlx.train.common.Q1k2SurveytmplLwConstant;
import q1k2.pxlx.train.dto.QuestionDto;

import java.util.*;

/**
 * @Description 调研管理单据插件
 * @Created 刘维
 */
public class SurveyBillPlugin extends AbstractBillPlugIn implements Plugin {
    //选择人员
    private final String SELECT_USER = "q1k2_btn_select_user";
    //选择组织
    private final String SELECT_ORG = "q1k2_btn_select_org";
    //人员单据标识
    private final String BOS_USER = "bos_user";
    //组织单据标识
    private final String BOS_ORG = "bos_org";
    //人员页签工具栏控件
    private final String Q1K2_ADVCONTOOLBARAP = "q1k2_advcontoolbarap";

    //组织页签工具栏控件
    private final String Q1K2_ADVCONTOOLBARAP1 = "q1k2_advcontoolbarap1";
    //自定义控件_试题
    private final String Q1K2_QUESTION = "q1k2_question";
    //保存试题
    private final String SAVEQUESTION = "saveQuestion";
    //选择模板
    private final String SELECTTMPL = "selectTmpl";

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        //监控人员和组织页签工具栏
        this.addItemClickListeners(Q1K2_ADVCONTOOLBARAP, Q1K2_ADVCONTOOLBARAP1);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //自定义控件_试题
        CustomControl questioncontrol = this.getControl(Q1K2_QUESTION);
        Map<String, Object> map = Maps.newHashMap();
        //试题列表值
        String contentJson = (String) this.getModel().getValue(Q1k2SurveyLwConstant.Q1K2_CONTENT_TAG);
        List<QuestionDto> questionList = JSON.parseArray(contentJson, QuestionDto.class);
        map.put("questionData", questionList);
        map.put("surveyType", "SURVEY");
        map.put("documentType", "SURVEY");
        map.put("operationstatus", getView().getFormShowParameter().getStatus().name());
        questioncontrol.setData(map);
    }

    @Override
    public void customEvent(CustomEventArgs e) {
        super.customEvent(e);
        String value = e.getEventArgs();
        String key = e.getKey();
        IDataModel model = this.getModel();
        if (Q1K2_QUESTION.equals(key) && SAVEQUESTION.equals(e.getEventName())) {
            //自定义控件等于试题 且 事件名称为保存试题
            //LargeTextOtherEdit content = this.getControl("q1k2_content");
            //保存试题列表
            //model.setValue(content.getTagFieldKey(), value);
            model.setValue(Q1k2SurveyLwConstant.Q1K2_CONTENT_TAG, value);
            //保存题目数量
            model.setValue(Q1k2SurveyLwConstant.Q1K2_NUM, JSON.parseArray(value).size());
        } else if (Q1K2_QUESTION.equals(key) && SELECTTMPL.equals(e.getEventName())) {
            //第一个参数为列表的单据标识，第二个参数为是否支持多选
            ListShowParameter showParameter = ShowFormHelper.createShowListForm(Q1k2SurveytmplLwConstant.FORMBILLID, false);
            showParameter.setCloseCallBack(new CloseCallBack(this, SELECTTMPL));
            //打开F7窗口
            this.getView().showForm(showParameter);
        }
    }

    @Override
    public void itemClick(ItemClickEvent evt) {
        super.itemClick(evt);
        if (SELECT_USER.equals(evt.getItemKey())) {//操作选择人员
            //第一个参数为列表的单据标识，第二个参数为是否支持多选
            ListShowParameter showParameter = ShowFormHelper.createShowListForm(BOS_USER, true);
            Set set = new HashSet();
            //人员单据体
            DynamicObjectCollection userEntitys = this.getModel().getEntryEntity(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_USER);
            for (int i = 0; i < userEntitys.size(); i++) {
                DynamicObject dynamicObject = userEntitys.get(i).getDynamicObject(Q1k2SurveyLwConstant.Q1K2_RANGE_USER);
                set.add(dynamicObject.getPkValue());
            }
            List<QFilter> qFilters = new ArrayList<QFilter>();
            //移除掉已经选中的人员
            qFilters.add(new QFilter("id", QCP.not_in, set));
            ListFilterParameter listFilterParameter = new ListFilterParameter(qFilters, null);
            showParameter.setListFilterParameter(listFilterParameter);
            showParameter.setCloseCallBack(new CloseCallBack(this, SELECT_USER));
            //打开F7窗口
            this.getView().showForm(showParameter);
        } else if (SELECT_ORG.equals(evt.getItemKey())) {//操作选择组织
            //第一个参数为列表的单据标识，第二个参数为是否支持多选
            ListShowParameter showParameter = ShowFormHelper.createShowListForm(BOS_ORG, true);
            Set set = new HashSet();
            //组织单据体
            DynamicObjectCollection orgEntitys = this.getModel().getEntryEntity(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_ORG);
            for (int i = 0; i < orgEntitys.size(); i++) {
                DynamicObject dynamicObject = orgEntitys.get(i).getDynamicObject(Q1k2SurveyLwConstant.Q1K2_RANGE_ORG);
                set.add(dynamicObject.getPkValue());
            }
            List<QFilter> qFilters = new ArrayList<QFilter>();
            //移除掉已经选中的组织
            qFilters.add(new QFilter("id", QCP.not_in, set));
            ListFilterParameter listFilterParameter = new ListFilterParameter(qFilters, null);
            showParameter.setListFilterParameter(listFilterParameter);
            showParameter.setCloseCallBack(new CloseCallBack(this, SELECT_ORG));
            //打开F7窗口
            this.getView().showForm(showParameter);
        }
    }


    @Override
    public void closedCallBack(ClosedCallBackEvent event) {
        super.closedCallBack(event);
        String actionId = event.getActionId();
        if (SELECT_USER.equals(actionId)) {//选择人员操作回调
            ListSelectedRowCollection returnData = (ListSelectedRowCollection) event.getReturnData();
            if (returnData != null && returnData.size() > 0) {
                //查询根据id人员数据
                QFilter qFilter = new QFilter("id", QCP.in, returnData.getPrimaryKeyValues());
                DynamicObject[] users = BusinessDataServiceHelper.load(BOS_USER, "id,name,billno", qFilter.toArray());
                //人员单据体
                DynamicObjectCollection userEntitys = this.getModel().getEntryEntity(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_USER);
                for (int i = 0; i < users.length; i++) {
                    DynamicObject dynamicObject = userEntitys.addNew();
                    dynamicObject.set(Q1k2SurveyLwConstant.Q1K2_RANGE_USER, users[i]);
                }
                //this.getModel().setValue(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_USER, userEntitys);
                //更新分录缓存
                this.getModel().updateEntryCache(userEntitys);
                //刷新人员单据体数据到前端
                this.getView().updateView(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_USER);
            }
        } else if (SELECT_ORG.equals(actionId)) {//选择组织操作回调
            ListSelectedRowCollection returnData = (ListSelectedRowCollection) event.getReturnData();
            if (returnData != null && returnData.size() > 0) {
                //查询根据id组织数据
                QFilter qFilter = new QFilter("id", QCP.in, returnData.getPrimaryKeyValues());
                DynamicObject[] orgs = BusinessDataServiceHelper.load(BOS_ORG, "id,name,billno", qFilter.toArray());
                //组织单据体
                DynamicObjectCollection orgEntitys = this.getModel().getEntryEntity(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_ORG);
                for (int i = 0; i < orgs.length; i++) {
                    DynamicObject dynamicObject = orgEntitys.addNew();
                    dynamicObject.set(Q1k2SurveyLwConstant.Q1K2_RANGE_ORG, orgs[i]);
                }
                //更新分录缓存
                this.getModel().updateEntryCache(orgEntitys);
                //刷新组织单据体数据到前端
                this.getView().updateView(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_ORG);
            }
        } else if (SELECTTMPL.equals(actionId)) {//选择模板
            ListSelectedRowCollection returnData = (ListSelectedRowCollection) event.getReturnData();
            if (returnData != null && returnData.size() > 0) {
                setTemplate(returnData);
            }
        }
    }

    /**
     * 设置模板数据
     *
     * @param returnData
     */
    private void setTemplate(ListSelectedRowCollection returnData) {
        //查询根据id试题模板数据
        QFilter qFilter = new QFilter("id", QCP.in, returnData.getPrimaryKeyValues());
        DynamicObject surveryTemplate = BusinessDataServiceHelper.loadSingle(Q1k2SurveytmplLwConstant.FORMBILLID, qFilter.toArray());
        //调研管理数据
        DynamicObject survery = this.getModel().getDataEntity();
        //试题列表
        Object tempContent = surveryTemplate.get(Q1k2SurveytmplLwConstant.Q1K2_CONTENT);
        survery.set(Q1k2SurveyLwConstant.Q1K2_CONTENT, tempContent);
        String tempContent_tag = surveryTemplate.getString(Q1k2SurveytmplLwConstant.Q1K2_CONTENT_TAG);
        survery.set(Q1k2SurveyLwConstant.Q1K2_CONTENT_TAG, tempContent_tag);
        this.getView().updateView(Q1k2SurveyLwConstant.Q1K2_CONTENT);
        //试题数量
        Object tempNum = surveryTemplate.get(Q1k2SurveytmplLwConstant.Q1K2_NUM);
        survery.set(Q1k2SurveyLwConstant.Q1K2_NUM, tempNum);
        this.getView().updateView(Q1k2SurveyLwConstant.Q1K2_NUM);
        //卷首语
        Object tempPreface = surveryTemplate.get(Q1k2SurveytmplLwConstant.Q1K2_PREFACE);
        survery.set(Q1k2SurveyLwConstant.Q1K2_PREFACE, tempPreface);
        this.getView().updateView(Q1k2SurveyLwConstant.Q1K2_PREFACE);
        //自定义控件_试题
        CustomControl questioncontrol = this.getControl(Q1K2_QUESTION);
        Map<String, Object> map = Maps.newHashMap();
        //试题列表值
        List<QuestionDto> questionList = JSON.parseArray(tempContent_tag, QuestionDto.class);
        map.put("questionData", questionList);
        map.put("surveyType", "SURVEY");
        map.put("documentType", "SURVEY");
        map.put("operationstatus", getView().getFormShowParameter().getStatus().name());
        //传时间戳,因为相同参数不会重复调用update
        map.put("skip", System.currentTimeMillis());
        questioncontrol.setData(map);
    }
}