package q1k2.pxlx.train.plugin.form;

import com.alibaba.fastjson.JSON;
import kd.bos.ext.form.control.CustomControl;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description 调研统计分析动态表单插件
 * @Created 刘维
 */
public class SurveyReportFormPlugin extends AbstractFormPlugin implements Plugin {
    //自定义控件_试题
    private final String Q1K2_QUESTION = "q1k2_survey_rpt";

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        //获取自定义参数(调研管理id)
        Long surveyId = this.getView().getFormShowParameter().getCustomParam("surveyId");
        Map<String, Object> surveyReportData = this.getSurveyReportData(surveyId);
        //获取自定义控件
        CustomControl customControl = this.getControl(Q1K2_QUESTION);
        //设置参数
        customControl.setData(surveyReportData);
    }

    private Map<String, Object> getSurveyReportData(Long surveyId) {
        Map<String, Object> surveyReportData = new HashMap<String, Object>();
        if (surveyId != null) {
            //自定义参数
            String answerList = " [\n" +
                    "        {\n" +
                    "            \"id\": \"1966857913863516160\",\n" +
                    "            \"content\": \"3\",\n" +
                    "            \"type\": \"QUESTION\",\n" +
                    "            \"num\": 1\n" +
                    "        }\n" +
                    "    ]";
            surveyReportData.put("answerList", JSON.parseArray(answerList));
            surveyReportData.put("finishNum", 1);
            String selectList = "[\n" +
                    "        {\n" +
                    "            \"id\": \"1966857901582593024\",\n" +
                    "            \"content\": \"1\",\n" +
                    "            \"type\": \"SINGLE\",\n" +
                    "            \"options\": [\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857901582594048\",\n" +
                    "                    \"content\": \"1\",\n" +
                    "                    \"num\": 1\n" +
                    "                },\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857901582594049\",\n" +
                    "                    \"content\": \"2\",\n" +
                    "                    \"num\": 1\n" +
                    "                },\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857901582594050\",\n" +
                    "                    \"content\": \"3\",\n" +
                    "                    \"num\": 0\n" +
                    "                },\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857901582594051\",\n" +
                    "                    \"content\": \"4\",\n" +
                    "                    \"num\": 0\n" +
                    "                }\n" +
                    "            ],\n" +
                    "            \"num\": 0\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"id\": \"1966857907714666496\",\n" +
                    "            \"content\": \"2\",\n" +
                    "            \"type\": \"MULTISELECT\",\n" +
                    "            \"options\": [\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857907714665472\",\n" +
                    "                    \"content\": \"1\",\n" +
                    "                    \"num\": 2\n" +
                    "                },\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857907714665473\",\n" +
                    "                    \"content\": \"2\",\n" +
                    "                    \"num\": 1\n" +
                    "                },\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857907714665474\",\n" +
                    "                    \"content\": \"3\",\n" +
                    "                    \"num\": 1\n" +
                    "                },\n" +
                    "                {\n" +
                    "                    \"id\": \"1966857907714665475\",\n" +
                    "                    \"content\": \"4\",\n" +
                    "                    \"num\": 0\n" +
                    "                }\n" +
                    "            ],\n" +
                    "            \"num\": 0\n" +
                    "        }\n" +
                    "    ]";
            surveyReportData.put("selectList", JSON.parseArray(selectList));
        }
        return surveyReportData;
    }
}