package q1k2.pxlx.train.plugin.form;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Maps;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.entity.datamodel.IDataModel;
import kd.bos.ext.form.control.CustomControl;
import kd.bos.form.events.CustomEventArgs;
import kd.sdk.plugin.Plugin;
import q1k2.pxlx.train.common.Q1k2SurveyLwConstant;
import q1k2.pxlx.train.dto.QuestionDto;

import java.util.EventObject;
import java.util.List;
import java.util.Map;

/**
 * @Description 调研与评估模板表单插件
 * @Created 刘维
 */
public class SurveyTempleBillPlugin extends AbstractBillPlugIn implements Plugin {
    //自定义控件_试题
    private final String Q1K2_QUESTION = "q1k2_question";

    //保存试题
    private final String SAVEQUESTION = "saveQuestion";

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
        //自定义控件_试题
        CustomControl questioncontrol = this.getControl(Q1K2_QUESTION);
        Map<String, Object> map = Maps.newHashMap();
        //试题列表值
        String contentJson = (String) this.getModel().getValue(Q1k2SurveyLwConstant.Q1K2_CONTENT_TAG);
        List<QuestionDto> questionList = JSON.parseArray(contentJson, QuestionDto.class);
        map.put("questionData", questionList);
        map.put("surveyType", "SURVEY");
        //map.put("documentType", "SURVEY");
        map.put("operationstatus", getView().getFormShowParameter().getStatus().name());
        questioncontrol.setData(map);
    }



    @Override
    public void customEvent(CustomEventArgs e) {
        super.customEvent(e);
        String value = e.getEventArgs();
        String key = e.getKey();
        IDataModel model = this.getModel();
        if (Q1K2_QUESTION.equals(key) && SAVEQUESTION.equals(e.getEventName())) {
            //自定义控件等于试题 且 事件名称为保存试题
            //LargeTextOtherEdit content = this.getControl("q1k2_content");
            //保存试题列表
            //model.setValue(content.getTagFieldKey(), value);
            model.setValue(Q1k2SurveyLwConstant.Q1K2_CONTENT_TAG, value);
            //保存题目数量
            model.setValue(Q1k2SurveyLwConstant.Q1K2_NUM, JSON.parseArray(value).size());
        }
    }
}