package q1k2.pxlx.train.plugin.form;

import com.kingdee.util.StringUtils;
import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.bill.OperationStatus;
import kd.bos.dataentity.entity.LocaleString;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.form.*;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.field.ComboEdit;
import kd.bos.form.field.ComboItem;
import kd.bos.list.IListView;
import kd.bos.list.ListShowParameter;
import kd.sdk.plugin.Plugin;
import q1k2.pxlx.train.common.Q1k2YearPlanConstant;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.EventObject;
import java.util.List;

/**
 * @Description 年度计划表单插件
 * @Created 刘维
 */
public class YearPlanBillPlugin extends AbstractBillPlugIn implements Plugin {
    //计划汇总
    private String PLANSUMMARY = "plansummary";

    @Override
    public void afterLoadData(EventObject e) {
        super.afterLoadData(e);
        setYearComboItems();
    }


    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        setYearComboItems();
    }

    /**
     * 设置年度下拉值
     */
    private void setYearComboItems() {
        Calendar calendar = Calendar.getInstance();
        int year = calendar.get(Calendar.YEAR);//当前年度
        //获取年度下拉控件
        ComboEdit ComboEdit = this.getControl(Q1k2YearPlanConstant.Q1K2_YEAR);
        //设置下拉值
        List<ComboItem> data = new ArrayList<>();
        for (int i = year - 3; i <= year + 3; i++) {
            data.add(new ComboItem(new LocaleString(String.valueOf(i)), String.valueOf(i)));
        }
        //绑定下拉值
        ComboEdit.setComboItems(data);
    }

    @Override
    public void afterDoOperation(AfterDoOperationEventArgs args) {
        super.afterDoOperation(args);
        // 计划汇总
        if (StringUtils.equals(PLANSUMMARY, args.getOperateKey())) {
            //第一个参数为列表的单据标识，第二个参数为是否支持多选
            ListShowParameter showParameter = ShowFormHelper.createShowListForm("q1k2_year_plan", true);
            showParameter.setCloseCallBack(new CloseCallBack(this, PLANSUMMARY));
            //打开F7窗口
            this.getView().showForm(showParameter);
        }
    }
}