package q1k2.pxlx.train.plugin.operate;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.PreparePropertysEventArgs;
import kd.bos.entity.plugin.args.EndOperationTransactionArgs;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.SaveServiceHelper;
import kd.sdk.plugin.Plugin;
import q1k2.pxlx.train.common.Q1k2SurveyLwConstant;
import q1k2.pxlx.train.common.Q1k2SurveyUserLwConstant;

import java.math.BigDecimal;
import java.util.List;

/**
 * 调研评估用户操作插件
 */
public class SurveyUserOperationServicePlugIn extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void onPreparePropertys(PreparePropertysEventArgs e) {
        super.onPreparePropertys(e);
        List<String> fieldKeys = e.getFieldKeys();
        fieldKeys.add(Q1k2SurveyUserLwConstant.Q1K2_USER);
        fieldKeys.add(Q1k2SurveyUserLwConstant.Q1K2_SURVEY);
        fieldKeys.add(Q1k2SurveyUserLwConstant.Q1K2_STATUS);
    }

    @Override
    public void endOperationTransaction(EndOperationTransactionArgs e) {
        super.endOperationTransaction(e);
        String operationKey = e.getOperationKey();
        DynamicObject[] dataEntities = e.getDataEntities();
        if ("delete".equals(operationKey)) {//删除
            for (int i = 0; i < dataEntities.length; i++) {
                DynamicObject surveyUserInfo = dataEntities[i];
                //根据主键查询调研管理数据
                //surveyInfo = BusinessDataServiceHelper.loadSingle(pkValue, Q1k2SurveyLwConstant.FORMBILLID);
                //用户
                DynamicObject user = surveyUserInfo.getDynamicObject(Q1k2SurveyUserLwConstant.Q1K2_USER);
                //状态
                String status = surveyUserInfo.getString(Q1k2SurveyUserLwConstant.Q1K2_STATUS);
                Long userPk = (Long) user.getPkValue();
                Object pkValue = surveyUserInfo.get(Q1k2SurveyUserLwConstant.Q1K2_SURVEY);
                //根据id查询调研管理数据
                DynamicObject survey = BusinessDataServiceHelper.loadSingle(pkValue, Q1k2SurveyLwConstant.FORMBILLID);
                //人员列表
                DynamicObjectCollection userRanges = survey.getDynamicObjectCollection(Q1k2SurveyLwConstant.Q1K2_SURVEY_RANGE_USER);
                userRanges.removeIf(userRange -> {
                    DynamicObject userInfo = userRange.getDynamicObject(Q1k2SurveyLwConstant.Q1K2_RANGE_USER);
                    return userPk.equals(userInfo.getPkValue());
                });
                //参与人数
                survey.set(Q1k2SurveyLwConstant.Q1K2_JOIN_NUM, userRanges.size());
                //完成人数
                int finishNum = survey.getInt(Q1k2SurveyLwConstant.Q1K2_FINISH_NUM);
                if ("FINISH".equals(status)) {
                    //删除人员状态为已完成,需要更新完成人数
                    survey.set(Q1k2SurveyLwConstant.Q1K2_FINISH_NUM, --finishNum);
                }
                BigDecimal finishNumDecimal = new BigDecimal(finishNum);
                BigDecimal joinNumDecimal = new BigDecimal(userRanges.size());
                BigDecimal finishRate = finishNumDecimal.divide(joinNumDecimal, 2, BigDecimal.ROUND_HALF_UP);
                //完成率
                survey.set(Q1k2SurveyLwConstant.Q1K2_FINISH_RATE, finishRate);
                //保存
                SaveServiceHelper.save(new DynamicObject[]{survey});
            }
        }
    }
}